;-----------------------------------------------------------------------
; DateiName        :  bench.asm
;-----------------------------------------------------------------------
; Autor            :  Christian Rsch
;
; Erstellungsdatum :  11.01.2002
;-----------------------------------------------------------------------
; Info : Dies ist ein "Benchmark-Programm" das verschiedene Mglichkeiten
;        Text auszugeben vergleicht.
;
;-----------------------------------------------------------------------


; Dies ist das Daten-Segment

data SEGMENT
assume DS:data
text    db "Drcken Sie eine Taste, um die Testlufe zu starten!",13,10,"$";<= "$" ist das Abschlussziechen fr DOS
b1st    db "Der Bildschirm wurde ","$";<= "$" ist das Abschlussziechen fr DOS
b2nd    db "mal beschrieben.",13,10,"$";<= "$" ist das Abschlussziechen fr DOS
v1t     db "Int 21h Funktion 9h bentigte ","$";<= "$" ist das Abschlussziechen fr DOS
v2t     db "Int 10h Funktion 0eh bentigte ","$";<= "$" ist das Abschlussziechen fr DOS
v3t     db "Das direkte Schreiben in den Speicher bentigte ","$";<= "$" ist das Abschlussziechen fr DOS
ticks   db " Ticks.",13,10,"$";<= "$" ist das Abschlussziechen fr DOS
measure db "Ein Tick entspricht 1/18,2 s.",13,10,"$";<= "$" ist das Abschlussziechen fr DOS
zeichen db "a","$"
t1      dw 0
t2      dw 0
t3      dw 0
data ends



; Dies ist das Stack-Segment

stackdata SEGMENT stack
assume SS:stackdata
        db 256 dup(?)           ; definiert die Grsse des Stacks
stackdata ends



; Dies ist das Code-Segment

code SEGMENT
ASSUME CS:code

;-----------------------------------------------------------------------
; Funktion        : PrintText
;-----------------------------------------------------------------------
; Info : gibt einen Text aus (via DOS)
;-----------------------------------------------------------------------
; IN  : DX: OFFSET des Strings
; OUT : ---
;-----------------------------------------------------------------------
PrintText PROC                  ; das muss evtl. vertauscht sein (TASM-Eigenheit)
        mov ax,0900h            ; Funktion 0900h (String ausgeben)
        int 21h                 ; Interrupt auslsen
        ret
ENDP

;-----------------------------------------------------------------------
; Funktion        : write_number
;-----------------------------------------------------------------------
; Info :  Schreibt die Zahl, die in AX ist, auf den Bildschirm
;-----------------------------------------------------------------------
; IN  : AX: auszugebende Zahl
;       BX: Basis
; OUT : ---
;-----------------------------------------------------------------------
write_number PROC
        push ax                 ; ax sichern
        push bx                 ; bx sichern
        push dx                 ; dx sichern

        mov  dx,-'0'            ; "Endzeichen" der Zahl

;       mov  bx,10
wn_goon:
        push dx                 ; Ziffer auf Stack
        xor  dx,dx
        div  bx                 ; durch 10 teilen
        cmp  ax,0
        jnz  wn_goon            ; weiter wenn noch nicht 0

        mov     ax,dx           ; erste Zahl holen
        add     ax,'0'          ; Zahl 2 ASCII
wn_output:
        mov     ah,0eh          ; Zeichen ausgeben
        xor     bl,0            ; Farbe 0
        cmp     al,'9'
        jle     wn_normal
        add     al,'a'-'0'-10
wn_normal:
        int     10h

        pop     ax              ; Zahl holen
        add     ax,'0'          ; Zahl 2 ASCII
        jnz     wn_output

        pop     dx              ; dx zurck
        pop     bx              ; bx zurck
        pop     ax              ; ax zurck

        ret
ENDP

;-----------------------------------------------------------------------
; Funktion        : print_v1
;-----------------------------------------------------------------------
; Info : berschreibt den Bildschirm x-mal mit einem Zeichen
;        benutzt Int 21h Funktion 9h
;-----------------------------------------------------------------------
; IN  : CX: Anzahl der gewnschten Durchlufe
; OUT :
;-----------------------------------------------------------------------
print_v1 PROC
        push cx         ;Register sichern
        push ax         ;Register sichern
        push dx         ;Register sichern
        push si         ;Register sichern

        mov dx,OFFSET zeichen
        mov ax,0900h
p1_next:
        mov zeichen, cl
        or  zeichen,00100000b
        mov si,2000
p1_nc:
        int 21h
        dec si
        jnz p1_nc

        dec cx
        jnz p1_next

        pop si          ;Register zurck
        pop dx          ;Register zurck
        pop ax          ;Register zurck
        pop cx          ;Register zurck
        ret
ENDP

;-----------------------------------------------------------------------
; Funktion        : print_v2
;-----------------------------------------------------------------------
; Info : berschreibt den Bildschirm x-mal mit einem Zeichen
;        benutzt Int 10h Funktion 0eh
;-----------------------------------------------------------------------
; IN  : CX: Anzahl der gewnschten Durchlufe
; OUT :
;-----------------------------------------------------------------------
print_v2 PROC
        push  cx        ;Register sichern
        push  si        ;Register sichern
        push  ax        ;Register sichern
        push  bx        ;Register sichern

        mov  ah,0eh
p2_next:
        mov al, cl
        or  al,00100000b
        mov si,2000
p2_nc:
        int 10h
        dec si
        jnz p2_nc

        dec cx
        jnz p2_next

        pop   bx        ;Register zurck
        pop   ax        ;Register zurck
        pop   si        ;Register zurck
        pop   cx        ;Register zurck
        ret
ENDP

;-----------------------------------------------------------------------
; Funktion        : print_v3
;-----------------------------------------------------------------------
; Info : berschreibt den Bildschirm x-mal mit einem Zeichen
;        schreibt direkt auf den Bildschirm
;-----------------------------------------------------------------------
; IN  : CX: Anzahl der gewnschten Durchlufe
; OUT :
;-----------------------------------------------------------------------
print_v3 PROC
        push cx         ;Register sichern
        push ax         ;Register sichern
        push bx         ;Register sichern
        push es         ;Register sichern
        push di         ;Register sichern

        mov bx,cx
        mov ax,0b800h
        mov es,ax
        cld
        mov ax,es:[0]   ;alte Farben behalten

p3_next:

        mov al, bl
        or  al,00100000b
        mov cx,2000      ;2000 WORDS
        xor di,di

        rep stosw       ; ab gehts!!!

        dec bx
        jnz p3_next

        pop di          ;Register zurck
        pop es          ;Register zurck
        pop bx          ;Register zurck
        pop ax          ;Register zurck
        pop cx          ;Register zurck
        ret
ENDP


;-----------------------------------------------------------------------
start:                          ; hier beginnt die Abarbeitung des Programms
        mov     ax, data        ; Adresse des Daten Segments nach ax
        mov     ds, ax          ; DatenSegment nach ds

        mov dx,OFFSET text      ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen
wait4key:
        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      wait4key        ; warten bis Taste gedrckt
        mov     ah,00h          ; Tastaturbuffer lesen
        int     16h

        mov     si,100

        mov     ax,00h
        int     1ah
        neg     dx
        mov     t1,dx

        mov     cx,si
        call    print_v1

        mov     ax,00h
        int     1ah
        add     t1,dx
        neg     dx
        mov     t2,dx

        mov     cx,si
        call    print_v2

        mov     ax,00h
        int     1ah
        add     t2,dx
        neg     dx
        mov     t3,dx

        mov     cx,si
        call    print_v3

        mov     ax,00h
        int     1ah
        add     t3,dx

        mov     bx,10

        mov dx,OFFSET b1st       ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov     ax,si
        call    write_number

        mov dx,OFFSET b2nd      ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov dx,OFFSET v1t       ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov     ax,t1
        call    write_number

        mov dx,OFFSET ticks      ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov dx,OFFSET v2t       ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov     ax,t2
        call    write_number

        mov dx,OFFSET ticks      ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov dx,OFFSET v3t       ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov     ax,t3
        call    write_number

        mov dx,OFFSET ticks      ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov dx,OFFSET measure     ; Offset des Textes nach dx
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov     ax, 4c00h       ; Funktion 4c00h (Programmende)
        int     21h             ; Interuppt auslsen


code ENDS



     end     start              ; Start als Einsprungpunkt definieren

;-----
; EOF
;-----
